// compile: g++ -std=gnu++11 -fopenmp -o openmp openmp.cc
#include <iostream>
#include <omp.h>
using namespace std;

const int NTHREAD = 4;
const int ARRAYSIZE = 1000000;
double sum=0.0, a[ARRAYSIZE];

int main() {
	for(double& n: a) n = 1.0;

	double my_sum;

	cout << "pthread equiv" << endl;
	#pragma omp parallel default(shared) private(my_sum) num_threads(4)
	{
		my_sum = 0.0;
		#pragma omp for
		for(int i=0; i<ARRAYSIZE; i++)
			my_sum += a[i];

		#pragma omp critical
		sum += my_sum;
	}
	cout << (int)sum << endl;

	sum = 0.0;
	cout << "a better way" << endl;
	#pragma omp parallel for default(shared) reduction(+:sum) num_threads(4)
	for(int i=0; i<ARRAYSIZE; i++)
		sum += a[i];
	cout << (int)sum << endl;
}
